function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from "react";
import { findDOMNode } from "react-dom";
import wrapDisplayName from "recompose/wrapDisplayName";
import setDisplayName from "recompose/setDisplayName";
import pick from "lodash/pick";
import isFunction from "lodash/isFunction";

var pickedProps = ["pageX", "pageY", "clientX", "clientY", "screenX", "screenY"];

export var defaultState = { mousePosition: undefined };

var withMousePosition = function withMousePosition(throttle) {
  return function (BaseComponent) {
    var WithMousePosition = function (_React$Component) {
      _inherits(WithMousePosition, _React$Component);

      function WithMousePosition() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, WithMousePosition);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WithMousePosition.__proto__ || Object.getPrototypeOf(WithMousePosition)).call.apply(_ref, [this].concat(args))), _this), _this.state = defaultState, _this.componentDidMount = function () {
          _this.dom = findDOMNode(_this);
          _this.dom.addEventListener("mousemove", _this.onMouseMove);
          _this.dom.addEventListener("mouseleave", _this.onMouseLeave);
        }, _this.componentWillUnmount = function () {
          if (isFunction(_this.onMouseMove.cancel)) {
            _this.onMouseMove.cancel();
          }

          _this.dom.removeEventListener("mousemove", _this.onMouseMove);
          _this.dom.removeEventListener("mouseleave", _this.onMouseLeave);
        }, _this.onMouseMove = throttle(function (e) {
          return _this.setState({ mousePosition: pick(e, pickedProps) });
        }), _this.onMouseLeave = function () {
          return _this.setState(defaultState);
        }, _this.render = function () {
          return React.createElement(BaseComponent, Object.assign({}, _this.props, _this.state));
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      return WithMousePosition;
    }(React.Component);

    if (process.env.NODE_ENV !== "production") {
      return setDisplayName(wrapDisplayName(BaseComponent, "withMousePosition"))(WithMousePosition);
    }

    return WithMousePosition;
  };
};

export default withMousePosition;