import { findDOMNode } from "react-dom";
import wrapDisplayName from "recompose/wrapDisplayName";
import setDisplayName from "recompose/setDisplayName";
import mapPropsOnEvent from "./mapPropsOnEvent";
import getOffsetToRoot from "./getOffsetToRoot";

var withOffsetToRoot = function withOffsetToRoot(throttle) {
  return function (BaseComponent) {
    var WithOffsetToRoot = mapPropsOnEvent(function () {
      return window;
    }, "resize", function (e, self) {
      return { offsetToRoot: getOffsetToRoot(findDOMNode(self)) };
    }, throttle, true)(BaseComponent);

    if (process.env.NODE_ENV !== "production") {
      return setDisplayName(wrapDisplayName(BaseComponent, "withMousePosition"))(WithOffsetToRoot);
    }

    return WithOffsetToRoot;
  };
};

export default withOffsetToRoot;