import wrapDisplayName from "recompose/wrapDisplayName";
import setDisplayName from "recompose/setDisplayName";
import pick from "lodash/pick";
import mapPropsOnEvent from "./mapPropsOnEvent";

export var pickedProps = ["innerWidth", "innerHeight", "outerWidth", "outerHeight"];

var withWindowSize = function withWindowSize(throttle) {
  return function (BaseComponent) {
    var WithWindowSize = mapPropsOnEvent(function () {
      return window;
    }, "resize", function () {
      return { windowSize: pick(window, pickedProps) };
    }, throttle, true)(BaseComponent);

    if (process.env.NODE_ENV !== "production") {
      return setDisplayName(wrapDisplayName(BaseComponent, "withWindowSize"))(WithWindowSize);
    }

    return WithWindowSize;
  };
};

export default withWindowSize;